# -*- coding: utf-8 -*-
u"""
Reflectivity from highly asymmetric crystal in backscattering
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

See the script: `tests/raycing/test_backcattering_xtal_Shvydko.py`.

A test for the optical scheme from [ShvydkoPRL2006]_, Fig 3.

.. imagezoom:: _images/shvydko-rc-ver.png
   :align: center

The blue curve was ray-traced by xrt. The dotted curve is a reconstruction from
Fig. 4 of [ShvydkoPRL2006]_. The dispersion rate was calculated from a linear
fit to the energy-angle line (orange) and is similar to that reported in
[ShvydkoPRL2006]_ as 8.5 µrad/meV.

.. [ShvydkoPRL2006] Yu. V. Shvyd’ko, M. Lerche, U. Kuetgens, H. D. Rüter,
   A. Alatas, and J. Zhao, Phys. Rev. Lett. 97 (2006) 235502
   (DOI: 10.1103/PhysRevLett.97.235502).

"""
__author__ = "Konstantin Klementiev"
__date__ = "2018 Feb 27"
